{% extends "base.html" %}

{% block links %}
{{ super() }}
{% endblock %}


{% block title %}
Générer ma convention
{% endblock %}




{% block header %}
{% include  "sub_templates/header.html" %}
{% endblock %}


{% block main %}
<h1 class="text-2xl font-semibold text-center mb-10">Générer la convention</h1>


<div id="background-layer" class=" layer fixed top-0 left-0 w-full h-full bg-[#00000066] z-20" onclick="closeLayers()">
</div>


<div
  class=" layer fullscreen-layer max-w-5xl flex bg-white rounded p-6 overflow-y-auto flex-col w-full z-20 fixed max-h-[90%] m-auto top-0 left-0 right-0 bottom-0 shadow h-fit max-w-[60%]">
  <h2 class="text-lg font-semibold text-center mb-4">Référence de l'offre</h2>


  <div class="flex flex-col mt-4">
    <label class="font-medium mb-2 text-gray-900 text-sm">Référence de l'offre</label>
    <input type="text" id="offer_ref" {% if offre %}value="" {% endif %}
      placeholder="Écrivez la référence de l'offre ici"
      class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2 resize-y"
      onchange="checkRef()">
  </div>

  <em class="mt-2 text-sm">*Remplissage auto des données de l'entreprise via la référence.</em>

  <span id="error-siret" class="text-red-600 text-sm text-center mt-3"></span>
</div>


<script>
  async function checkRef() {
    const ref = document.querySelector('#offer_ref').value.trim()
    let res = await fetch(`/api/offre/${ref}/exists`, {
      method: 'GET'
    })
    res = await res.json()

    document.querySelector('#error-siret').innerText = ''
    if (res.code == 0) {
      document.querySelector('#error-siret').innerText =
        `La référence de l'offre n'existe pas dans la base de données.`
      return
    }


    console.log('res', res)

    const offre = res.object
    const company = res.object.company
    const responsable = res.object.company.responsable

    document.querySelector('[name="company_name"]').value = company.name
    document.querySelector('[name="company_siret"]').value = company.siret
    document.querySelector('[name="company_city"]').value = company.ville
    document.querySelector('[name="company_address"]').value = company.address
    document.querySelector('[name="company_cpostal"]').value = company.cpostal
    document.querySelector('[name="company_email"]').value = company.contact_email
    document.querySelector('[name="company_phone"]').value = company.contact_phone
    document.querySelector('[name="responsable_name"]').value = responsable.first_name + ' ' + responsable.last_name
    document.querySelector('[name="responsable_email"]').value = responsable.email
    document.querySelector('[name="responsable_number"]').value = responsable.phone_number

    document.querySelector('[name="stage_topic"]').value = offre.titre
    console.log('res', res)

    closeLayers()
  }

  function checkDays() {
    const oneDay = 24 * 60 * 60 * 1000
    const firstDate = new Date(document.querySelector('[name="stage_date_debut"]').value)
    const secondDate = new Date(document.querySelector('[name="stage_date_fin"]').value)

    const diffDays = Math.round(Math.abs((firstDate - secondDate) / oneDay))

    console.log('diffDays', diffDays)

    document.querySelector('[name="stage_days_duration"]').value = diffDays
    document.querySelector('[name="stage_weeks_duration"]').value = Math.ceil(diffDays / 7)
  }
</script>



<form method="POST" class="flex gap-4 flex-col"
  onsubmit="alert('La convention a bien été généré. Elle doit être validée et signée par le responsable du département avant que vous la receviez.')">
  <div class="flex gap-4">
    <div class="shadow rounded px-4 py-3 gap-4 flex flex-col flex-1">
      <h2 class="text-lg font-semibold text-center mb-4">Etablissement & responsable</h2>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Nom de l'entreprise</label>
        <input name="company_name" type="text" value="" required placeholder="Écrivez le nom de l'entreprise ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>



      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">SIRET de l'entreprise</label>
        <input name="company_siret" type="number" value="" required placeholder="Écrivez le SIRET de l'entreprise ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Ville de l'entreprise</label>
        <input name="company_city" type="text" required value="" placeholder="Écrivez la ville de l'entreprise ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Code postal de l'entreprise</label>
        <input name="company_cpostal" type="text" required value="" placeholder="Écrivez le code postal de l'entreprise ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Adresse de l'entreprise</label>
        <input name="company_address" type="text" required placeholder="Écrivez l'adresse de l'entreprise ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>




      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Adresse email de l'entreprise</label>
        <input name="company_email" type="email" required placeholder="Écrivez l'adresse email de l'entreprise ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>



      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Numéro de téléphone de l'entreprise</label>
        <input name="company_phone" type="tel" required placeholder="Écrivez le numéro de téléphone de l'entreprise ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>





      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Nom et prénom du responsable</label>
        <input name="responsable_name" type="text" required placeholder="Écrivez le nom du responsable ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>


      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Qualité du représentant</label>
        <input name="responsable_poste" type="text" required placeholder="Écrivez le nom du responsable ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>




      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Email du responsable</label>
        <input name="responsable_email" type="email" required placeholder="Écrivez l'email du responsable ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Numéro de téléphone du responsable</label>
        <input name="responsable_number" type="tel" required
          placeholder="Écrivez le numéro de téléphone du responsable ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>


      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Nom et prénom de l'enseignant référent</label>
        <input name="name_teacher" type="text" required
          placeholder="Écrivez le nom et prénom de l'enseignant référent ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>


      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Email de l'enseignant référent</label>
        <input name="email_teacher" type="email" required placeholder="Écrivez l'email de l'enseignant référent ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>
    </div>



    <div class="shadow rounded px-4 py-3 gap-4 flex flex-col flex-1">
      <h2 class="text-lg font-semibold text-center mb-4">Stagiaire</h2>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Nom du stagiaire</label>
        <input name="stagiaire_lname" type="text" required value="{{ user.last_name }}" readonly
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Prénom du stagiaire</label>
        <input name="stagiaire_fname" type="text" required value="{{ user.first_name }}" readonly
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Date de naissance du stagiaire</label>
        <input name="stagiaire_birth_date" type="date" required
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Sexe du stagiaire</label>
        <select name="stagiaire_sex" required
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
          <option value="men">Homme</option>
          <option value="women">Femme</option>
        </select>
      </div>


      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Adresse du stagiaire</label>
        <input name="stagiaire_address" type="text" required placeholder="Écrivez l'adresse du stagiaire ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>


      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Numéro de téléphone du stagiaire</label>
        <input name="stagiaire_phone" type="tel" required placeholder="Écrivez le numéro de téléphone du stagiaire ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Adresse email du stagiaire</label>
        <input name="stagiaire_email" type="text" required value="{{ user.email }}"
          placeholder="Écrivez l'adresse email du stagiaire ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>


      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Intitulé complet de la formation</label>
        <input name="formation_name" type="text" required placeholder="Écrivez l'intitulé complet de la formation ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>
    </div>

  </div>



  <div class="flex gap-4">

    <div class="shadow rounded px-4 py-3 gap-4 flex flex-col flex-1">
      <h2 class="text-lg font-semibold text-center mb-4">Stage</h2>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Sujet du stage</label>
        <input name="stage_topic" type="text" required placeholder="Écrivez le sujet du stage ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Date de début du stage</label>
        <input name="stage_date_debut" type="date" required onchange="checkDays()"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Date de fin du stage</label>
        <input name="stage_date_fin" type="date" required onchange="checkDays()"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>


      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Durée du stage (en semaines)</label>
        <input name="stage_weeks_duration" readonly type="number" required
          placeholder="Écrivez la durée du stage (en semaines) ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>


      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Durée du stage (en jours)</label>
        <input name="stage_days_duration" readonly type="number" required
          placeholder="Écrivez la durée du stage (en jours) ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Temps horaire par semaine</label>
        <input name="stage_week_hours" type="number" required placeholder="Écrivez le temps horaire par semaine ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>


      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Salaire horaire</label>
        <input name="stage_hour_salary" type="number" required placeholder="Écrivez le salaire horaire ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Nom du tuteur de stage</label>
        <input name="tuteur_name" type="text" required placeholder="Écrivez le nom du tuteur du stage ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>
      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Adresse email du tuteur de stage</label>
        <input name="tuteur_email" type="email" required placeholder="Écrivez l'adresse email du tuteur de stage ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>

    </div>


    <div class="shadow rounded px-4 py-3 gap-4 flex flex-col flex-1">
      <h2 class="text-lg font-semibold text-center mb-4">Convention & représentant</h2>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Date de la convention</label>
        <input name="convention_date" type="date" required readonly placeholder="Écrivez la date de la convention ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
        <script>
          document.querySelector('[name="convention_date"]').valueAsDate = new Date()
        </script>
      </div>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Ville de réalisation de la convention</label>
        <input name="convention_city" type="text" required
          placeholder="Écrivez la ville de réalisation de la convention ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>

      <div class="flex flex-col">
        <label class="font-medium mb-2 text-gray-900 text-sm">Nom complet du représentant de l'établissement</label>
        <input name="name_representant" type="text" required
          placeholder="Écrivez le nom complet du représentant de l'établissement ici"
          class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2">
      </div>

    </div>


  </div>








  <button type="submit"
    class="rounded-full pointer px-3 py-[5px] mb-1 text-white bg-[var(--blue)] mt-5 border border-[var(--blue)] font-semibold hover:bg-white hover:text-[var(--blue)] duration-300 shadow mx-auto flex">Générer
    la convention</button>
</form>


{% endblock %}

{% block footer %}
{% include  "sub_templates/footer.html" %}
{% endblock footer%}


{% block script %}
{{ super() }}
{% endblock %}